
import sys
import os
import os.path
import string
import Image
import Index
from Params import Params
from Index import IndexMixIn

class DbFilm:
	def __init__(self, path):
		self.path=path
		self.photos=[]
		self.indexes=[]

	def getPhoto(self, idx):
		try:
			if idx>=0:
				return self.photos[idx]
		except:
			pass
		return None

	def getPath(self):
		return self.path

	def add(self, photo):
		self.photos.append(Image.Image(photo, self))

	def getPhotos(self):
		return self.photos

	def createIndexes(self):
		Index.reset()
		import copy
		photos=copy.copy(self.photos)
		photosPerIndex=Params.rows*Params.columns
		while photos:
			if len(photos)>=photosPerIndex:
				self.indexes.append(IndexMixIn(photos[:photosPerIndex], self))
				del photos[:photosPerIndex]
			else:
				self.indexes.append(IndexMixIn(photos, self))
				photos=[]

		for index in self.indexes:
			index.createFile()

	def getPreviousIndex(self, index):
		try:
			idx=self.indexes.index(index)
			if idx>0:
				return self.indexes[idx-1]
		except:
			pass
		return None

	def getNextIndex(self, index):
		try:
			idx=self.indexes.index(index)
			return self.indexes[idx+1]
		except:
			return None
		

class DbPhotos:
	def __init__(self):
		self.films=[]

	def isPhoto(self, file):
		if self.isThumbnail(file) or self.isWebImage(file) or file in Params.reservedFilenames:
			return 0
		try:
			return file[string.rindex(file, '.')+1:] in Params.photos
		except:
			return 0

	def isThumbnail(self, file):
		return file[string.rfind(file, '/')+1:][:4]=='thm_'

	def isWebImage(self, file):
		return file[string.rfind(file, '/')+1:][:4]=='web_'

	def sort(self, listDir):
		toDel=[]
		toAdd=[]
		listDir.sort()
		idx=0
		for file in listDir:
			if os.path.isdir(file):
				toDel.insert(0, idx)
				toAdd.append(file)
			idx=idx+1

		for idx in toDel:
			del listDir[idx]
		return listDir+toAdd

	def addDirectory (self, path):
		self.path=path
		flagNewDirectory=1
		try:
			listDir=os.listdir(self.path)
		except:
			sys.stderr.write("Warning: Can't open %s - directory ignored\n" % 
                          self.path)
			return

		if listDir:
			listDir=map(os.path.join, len(listDir)*[path], listDir)
			listDir=self.sort(listDir)

		while listDir:
			file=listDir[0]
			del listDir[0]

			# directory ?
			if os.path.isdir(file) and file[string.rfind(file, '/')+1]!='.':
				flagNewDirectory=1
				path=file
				try:
					content=os.listdir(file)
				except:
					content=[]
				content=self.sort(content)
				if content:
					listDir=map(os.path.join, len(content)*[path], content)+listDir
			elif os.access(path, os.W_OK):
				# jpeg file ?
				if os.path.isfile(file) and file[string.rfind(file, '/')+1]!='.' \
			   	and self.isPhoto(file[string.rfind(file, '/')+1:]):
					if flagNewDirectory:
						flagNewDirectory=0
						self.films.append(DbFilm(path))
						for navButtons in ["prev.gif", "next.gif", "toc.gif"]:
							input=Params.ressources.open(navButtons)
							output=open(os.path.join(path, navButtons), "w")
							output.write(input.read())
							output.close()
							input.close()
					self.films[-1].add(file)

	def getFilms(self):
		return self.films

