
import os
import os.path
import Comments
import string
from Params import Params

class Image:
	try:
		import pImaging
		__pImagingAvailable=not Params.disableImaging
	except:
		__pImagingAvailable=0
	__comments=None

	def __init__(self, path, film):
		self.name=path[string.rfind(path, '/')+1:]
		self.path=path[:string.rfind(path, '/')+1]
		self.film=film
		self.idx=len(film.getPhotos())
		self.size=()
		self.thumbnail="thm_"+self.name
		self.webImage="web_"+self.name
		self.loadThumbnailSize()

		if (not Image.__comments) or Image.__comments.path!=self.film.getPath():
			Image.__comments=Comments.Comments(self.film.getPath())
		self.comment=Image.__comments.getComment(self.name)
	
	def getPath(self):
		return self.path

	def getPhoto(self):
		return self.name

	def getSize(self):
		if Image.__pImagingAvailable:
			if not self.size:
				import pImaging
				self.size=pImaging.size(os.path.join(self.path, self.name));
		else:
			self.size=(0,0)
		return self.size;

	def getThumbnailSize(self):
		return self.thumbnailSize;

	def loadThumbnailSize(self):
		if Image.__pImagingAvailable:
			import pImaging
			path=self.film.getPath()
			size=(0, 0)
			if "thm" in Params.overwrite or not \
			   os.path.exists(os.path.join(self.film.getPath(), self.thumbnail)):
				if Params.thumbnailSize:
					size=pImaging.resize(os.path.join(path, self.name),
					                os.path.join(path, self.thumbnail),
										 Params.thumbnailSize);
				else:
					size=pImaging.scale(os.path.join(path, self.name),
					                os.path.join(path, self.thumbnail),
										 Params.thumbnailRatio);
			elif not Params.forceThmSize:
				size=pImaging.size(os.path.join(path, self.thumbnail))
			self.thumbnailSize=size
			if not os.path.exists(os.path.join(self.film.getPath(), self.webImage)):
				if Params.webImageSize:
					pImaging.resize(os.path.join(path, self.name),
					                os.path.join(path, self.webImage),
										 Params.webImageSize);
				elif Params.webImageRatio:
					pImaging.scale(os.path.join(path, self.name),
					                os.path.join(path, self.webImage),
										 Params.webImageRatio);
		else:
			self.thumbnailSize=(0,0)
		if Params.forceThmSize:
			self.thumbnailSize=(Params.forceThmSize, Params.forceThmSize)
		
	def getThumbnail(self):
		return self.thumbnail

	def htmlFilename(self):
		return self.name[:string.rindex(self.name, ".")]+".html"

	def getComment(self):
		return self.comment
	
	def getPrevious(self):
		return self.film.getPhoto(self.idx-1)
	
	def getNext(self):
		return self.film.getPhoto(self.idx+1)
