
import html
from Params import Params
from Photo import PhotoMixIn


def reset():
	Index.__count__=0

class Index:
	__count__=0

	def __init__(self, photos, film):
		self.photos=photos
		self.maxThumbnailSize=max(map(lambda i: max(i.getThumbnailSize()), 
		                              photos))
		self.film=film
		if not Index.__count__:
			self.htmlFilename="index.html"
		else:
			self.htmlFilename="index.%d.html" % Index.__count__
		Index.__count__=Index.__count__+1
		self.path=self.film.getPath()

	def getFilename(self):
		return self.htmlFilename

	def nextButton(self, data=None):
		next=self.film.getNextIndex(self)
		if next:
			a=html.a(next.getFilename())
			a.add(html.img("next.gif", {"alt":"next", "border": "0"}))
			return a
		return ""
			

	def previousButton(self, data=None):
		prev=self.film.getPreviousIndex(self)
		if prev:
			a=html.a(prev.getFilename())
			a.add(html.img("prev.gif", {"alt":"previous", "border": "0"}))
			return a
		return ""

	def thumbnail(self, photo, data=None):
		htmlPhoto=PhotoMixIn(photo, self.htmlFilename)
		htmlPhoto.createFile()

		thumbnail=photo.getThumbnail()
		if self.maxThumbnailSize:
			td=html.td({"align": "center", "valign": "middle", 
		            	"height": "%s" % self.maxThumbnailSize,
		            	"width": "%s" % self.maxThumbnailSize})
		else:
			td=html.td({"align": "center", "valign": "middle"})

		a=html.a(photo.htmlFilename())

		comment=photo.getComment()
		if comment:
			img=html.img(thumbnail, {"title": comment, "alt": comment, "border": "0"})
		else:
			img=html.img(thumbnail, {"alt": photo.getPhoto(), "border": "0"})

		a.add(img)
		td.add(a)
		return td

	def row(self, photos, data=None):
		tr=html.tr()
		for photo in photos:
			tr.add(self.thumbnail(photo))
		return tr

	def table(self, data=None):
		table=html.table()
		photos=[]
		for photo in self.photos:
			photos.append(photo)
			if len(photos)==Params.columns:
				table.add(self.row(photos))
				photos=[]

		if photos:
			table.add(self.row(photos))
		return table
			
	def page(self, data=None):
		mainTable=html.table({"border": "1"})

		navButtons=None
		prev=self.previousButton()
		if prev:
			if not navButtons:
				navButtons=html.tr()
			td=html.td()
			td.add(prev)
			navButtons.add(td)
		next=self.nextButton()
		if next:
			if not navButtons:
				navButtons=html.tr()
			td=html.td()
			td.add(next)
			navButtons.add(td)

		if navButtons:
			table=html.table()
			table.add(navButtons)
			navButtons=table
			tr=html.tr()
			td=html.td()
			td.add(navButtons)
			tr.add(td)
			mainTable.add(tr)

		tr=html.tr()
		td=html.td()
		td.add(self.table())
		tr.add(td)
		mainTable.add(tr)

		if navButtons:
			tr=html.tr()
			td=html.td()
			td.add(navButtons)
			tr.add(td)
			mainTable.add(tr)
		
		return mainTable

from Documents import HtmlFile
class IndexMixIn(Index, HtmlFile):
	pass
