
import string
import Ressources

class Params:
	reservedFilenames=["prev.gif", "toc.gif", "next.gif"]
	photos=["jpg", "jpeg", "png", "gif", "tiff", "bmp"]

	columns=5
	rows=5
	thumbnailSize=0
	thumbnailRatio=0
	webImageSize=0
	webImageRatio=0
	webImageLink=0
	useWebImage=0
	directories=[]
	ressources=None
	comments=["top", "bottom"]
	overwrite=["html"]
	forceThmSize=0
	disableImaging=0
	albumName="generated by photon - http://photon.project.free.fr"

		
	def __init__(self, params):
		self.params=params

		bindings={}
		bindings["c"]=(lambda s, x: Params.setAttr(s, "columns", x), 
		               self.getInteger)
		bindings["r"]=(lambda s, x: Params.setAttr(s, "rows", x), 
		               self.getInteger)
		bindings["t"]=(lambda s, x: Params.setAttr(s, "thumbnailSize", x), 
		               self.getInteger)
		bindings["s"]=(lambda s, x: Params.setAttr(s, "thumbnailRatio", x), 
		               self.getFloat)
		bindings["o"]=(lambda s, x: Params.setAttr(s, "comments", x, 
		                ["top", "bottom"]), self.getString)
		bindings["w"]=(lambda s, x: Params.setAttr(s, "overwrite", x, 
		                ["thm", "html"]), self.getString)
		bindings["f"]=(lambda s, x: Params.setAttr(s, "forceThmSize", x), 
		               self.getInteger)
		bindings["i"]=(lambda s, x: Params.setAttr(s, "disableImaging", x), 
		               self.dummy)
		bindings["a"]=(lambda s, x: Params.setAttr(s, "albumName", x), 
		               self.getString)

		bindings["columns"]=bindings["c"]
		bindings["rows"]=bindings["r"]
		bindings["thumbnailSize"]=bindings["t"]
		bindings["thumbnailRatio"]=bindings["s"]
		bindings["comments"]=bindings["o"]
		bindings["overwrite"]=bindings["w"]
		bindings["force-thm-size"]=bindings["f"]
		bindings["disable-imaging"]=bindings["i"]
		bindings["album"]=bindings["a"]
		bindings["webImageSize"]=(lambda s, x: Params.setAttr(s, "webImageSize", x),self.getInteger)
		bindings["webImageRatio"]=(lambda s, x: Params.setAttr(s, "webImageRatio", x),self.getFloat)
		bindings["webImageLink"]=(lambda s, x: Params.setAttr(s, "webImageLink", x),self.dummy)
		bindings["useWebImage"]=(lambda s, x: Params.setAttr(s, "useWebImage", x),self.dummy)

		param=self.getNext()
		while param:
			if param[:2]=="--":
				try:
					name, value=string.split(param[2:], "=")
				except:
					if name[1]==self.dummy:
						value=None
					else:
						raise

				bindings[name][0](self, bindings[name][1](value))
			elif param[:1]=="-":
				name=param[1:]
				bindings[name][0](self, bindings[name][1]())
			else:
				Params.directories.append(param)
			param=self.getNext()

		if (not Params.thumbnailSize) and (not Params.thumbnailRatio):
			Params.thumbnailSize=120

		if Params.webImageSize or Params.webImageRatio:
			Params.useWebImage=1

		Params.ressources=Ressources.Ressources()

	def dummy(self, param=None):
		return 1 

	def getNext(self):
		if self.params:
			param=self.params[0]
			del self.params[0]
			return param
		else:
			return ""

	def getInteger(self, param=None):
		if param:
			return string.atoi(param)
		else:
			return string.atoi(self.getNext())

	def getFloat(self, param=None):
		if param:
			return string.atof(param)
		else:
			return string.atof(self.getNext())

	def getString(self, param=None):
		if param:
			return param
		else:
			return self.getNext()

	def setAttr(self, name, value, allowedValues=None):
		if isinstance(Params.__dict__[name], type([])):
			values=string.split(string.lower(value), ",")
			Params.__dict__[name]=[]
			for value in values:
				if value=="all":
					Params.__dict__[name]=allowedValues
					return
				elif value=="none":
					return
				elif value in allowedValues:
					Params.__dict__[name].append(value)
				else:
					raise "invalid value"
		else:
			Params.__dict__[name]=value
