import html
from Params import Params
import os.path

class Photo:
	def __init__(self, image, index):
		self.img=image
		self.index=index
		self.path=image.getPath()
		self.htmlFilename=image.htmlFilename()
		if os.path.exists(os.path.join(self.path, self.htmlFilename)) and not \
		   "html" in Params.overwrite:
			self.htmlFilename=""

	def nextButton(self, data=None):
		next=self.img.getNext()
		if next:
			a=html.a(next.htmlFilename())
			a.add(html.img("next.gif",{"alt":"next", "border": "0"}))
			return a
		return ""

	def previousButton(self, data=None):
		prev=self.img.getPrevious()
		if prev:
			a=html.a(prev.htmlFilename())
			a.add(html.img("prev.gif",{"alt":"previous", "border": "0"}))
			return a
		return ""

	def indexButton(self, data=None):
		a=html.a(self.index)
		a.add(html.img("toc.gif",{"alt":"index", "border": "0"}))
		return a

	def comment(self, data=None):
		if self.img.getComment():
			tr=html.tr()
			td=html.td({"align": "center"})
			td.add(self.img.getComment())
			tr.add(td)
			return tr
		return ""

	def image(self, data=None):
		photo=self.img.getPhoto()
		comment=self.comment()
		table=html.table()
		if comment and "top" in Params.comments:
			table.add(comment)
		tr=html.tr()
		td=html.td()
		if self.img.getComment():
			if Params.useWebImage:
				img=html.img("web_"+photo, {"title": self.img.getComment(), "alt": self.img.getComment(), "border": "0"})
			else:
				img=html.img(photo, {"title": self.img.getComment(), "alt": self.img.getComment(), "border": "0"})
		else:
			if Params.useWebImage:
				img=html.img("web_"+photo, {"alt": photo, "border": "0"})
			else:
				img=html.img(photo, {"alt": photo, "border": "0"})
		if Params.webImageLink:
			a=html.a(photo)
			a.add(img)
			td.add(a)
		else:
			td.add(img)
		tr.add(td)
		table.add(tr)
		if comment and "bottom" in Params.comments:
			table.add(comment)
		return table


	def page(self, data=None):
		mainTable=html.table({"border": "1"})

		navButtons=html.tr()
		prev=self.previousButton()
		if prev:
			td=html.td()
			td.add(prev)
			navButtons.add(td)
		index=self.indexButton()
		if index:
			td=html.td()
			td.add(index)
			navButtons.add(td)
		next=self.nextButton()
		if next:
			td=html.td()
			td.add(next)
			navButtons.add(td)

		if navButtons:
			table=html.table()
			table.add(navButtons)
			navButtons=table
			tr=html.tr()
			td=html.td()
			td.add(navButtons)
			tr.add(td)
			mainTable.add(tr)

		tr=html.tr()
		td=html.td()
		td.add(self.image())
		tr.add(td)
		mainTable.add(tr)

		if navButtons:
			tr=html.tr()
			td=html.td()
			td.add(navButtons)
			tr.add(td)
			mainTable.add(tr)
		
		return mainTable

from Documents import HtmlFile
class PhotoMixIn(Photo, HtmlFile):
	pass
