import urllib

class element:
	def __init__(self, tag, attrs={}):
		self.tag=tag
		self.attrs=attrs.copy()

	def __repr__(self):
		output="<"+self.tag
		for attr in self.attrs.keys():
			if self.attrs[attr]:
				output=output+" "+attr+"=\""+self.attrs[attr]+"\""
			else:
				output=output+" "+attr
		output=output+">"
		return output
	
class emptyElement(element):
	def __init__(self, tag, attrs={}):
		element.__init__(self, tag, attrs)

	def __repr__(self):
		output="<"+self.tag
		for attr in self.attrs.keys():
			if isinstance(self.attrs[attr], type("")):
				if self.attrs[attr]:
					output=output+" "+attr+"=\""+self.attrs[attr]+"\""
				else:
					output=output+" "+attr
		output=output+" />"
		return output
	
class container(element):
	def __init__(self, tag, attrs={}):
		element.__init__(self, tag, attrs)
		self.items=[]

	def add(self, item):
		if (item):
			if isinstance(item, type([])):
				for elt in item:
					self.add(elt)
			else:
				self.items.append(item);

	def __repr__(self):
		output=element.__repr__(self)+"\n"
		for item in self.items:
			if isinstance(item, element):
				output=output+item.__repr__()+"\n"
			else:
				if isinstance(item, type("")):
					output=output+item+"\n"
		output=output+"</"+self.tag+">"
		return output


class p(container):
	def __init__(self, attrs={}):
		container.__init__(self, "p", attrs)


class td(container):
	def __init__(self, attrs={}):
		container.__init__(self, "td", attrs)


class tr(container):
	def __init__(self, attrs={}):
		container.__init__(self, "tr", attrs)


class th(container):
	def __init__(self, attrs={}):
		container.__init__(self, "th", attrs)


class table(container):
	def __init__(self, attrs={}):
		container.__init__(self, "table", attrs)


class a(container):
	def __init__(self, href="", attrs={}):
		if href:
			attrs["href"]=href
			# attrs["href"]=urllib.quote_plus(href)
		container.__init__(self, "a", attrs)


class ul(container):
	def __init__(self, attrs={}):
		container.__init__(self, "ul", attrs)


class li(container):
	def __init__(self, attrs={}):
		container.__init__(self, "li", attrs)


class img(emptyElement):
	def __init__(self, src="", attrs={}):
		if src:
			attrs["src"]=src

		if not attrs.has_key("alt"):
			attrs["alt"]=attrs["src"]

		emptyElement.__init__(self, "img", attrs)


class small(container):
	def __init__(self, attrs={}):
		container.__init__(self, "small", attrs)


class big(container):
	def __init__(self, attrs={}):
		container.__init__(self, "big", attrs)


class em(container):
	def __init__(self, attrs={}):
		container.__init__(self, "em", attrs)


class menu(container):
	def __init__(self, attrs={}):
		container.__init__(self, "menu", attrs)


class body(container):
	def __init__(self, attrs={}):
		container.__init__(self, "body", attrs)


class title(container):
	def __init__(self, attrs={}):
		container.__init__(self, "title", attrs)


class head(container):
	def __init__(self, attrs={}):
		container.__init__(self, "head", attrs)

class meta(emptyElement):
	def __init__(self, attrs={}):
		emptyElement.__init__(self, "meta", attrs)


class html(container):
	def __init__(self, attrs={}):
		if not attrs.has_key("xmlns"):
			attrs["xmlns"]="http://www.w3.org/1999/xhtml" 
		if not attrs.has_key("xml:lang"):
			attrs["xml:lang"]="en" 
		if not attrs.has_key("lang"):
			attrs["lang"]="en"

		container.__init__(self, "html", attrs)

	def __repr__(self):
		# Modified to work with mod_python
		# output="Content-type: text/html\n\n"
		output="<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n"
		output=output+"<!DOCTYPE html PUBLIC "
		output=output+"\"-//W3C//DTD XHTML 1.0 Transitional//EN\" "
		output=output+"\"DTD/xhtml1-transitional.dtd\">\n"
		output=output+"<!-- Generated by photon - "
		output=output+"http://photon.project.free.fr/ -->\n"

		output=output+element.__repr__(self)+"\n"
		for item in self.items:
			if isinstance(item, element):
				output=output+item.__repr__()+"\n"
			else:
				output=output+item+"\n"
		output=output+"</%s>" % (self.tag)
		return output
